#include <string.h> // memcmp

#include "common.h"


const char* OsdErrorToString(eOsdError err)
{
  const char* e = "Unknown";
  switch (err)
  {
    case oeOk:              e = "Ok"; break;
    case oeTooManyAreas:    e = "Too Many Areas"; break;
    case oeTooManyColors:   e = "Too Many Colors"; break;
    case oeBppNotSupported: e = "Bpp Not Supported"; break;
    case oeAreasOverlap:    e = "Areas Overlap"; break;
    case oeWrongAlignment:  e = "Wrong Alignment"; break;
    case oeOutOfMemory:     e = "Out Of Memory"; break;
    case oeWrongAreaSize:   e = "Wrong Area Size"; break;
    case oeUnknown: break;
  }
  return e;
}


bool Equals(const uint8_t* d1, const uint8_t* d2, int length)
{
  return !memcmp(d1, d2, length); // memcmp returns 0 if d1=d2
}

#ifdef NACC_DEBUG
#include <stdarg.h>

static uint8_t logType = 0;

void setLogType(uint8_t type) { logType = type; }

void dprint(uint8_t type, const char* msg, ...)
{
  if (!msg) return;
  
  if (!(type & logType)) return; // no logging for this type
  
  char* output = NULL;
  va_list ap;
  va_start(ap, msg);
  vasprintf(&output, msg, ap);
  va_end(ap);
   
  if (type == L_ERR)  
    fprintf(stderr, "[NACC] \033[31m%s\n\033[0m", output);
  else if (type == L_TXT || type == L_DAT)
    fprintf(stderr, "%s", output);   
  else 
    fprintf(stderr, "[NACC] %s\n", output);
     
  fflush(stderr);
  free(output);  
}

#endif
