#ifndef __NACC_Manager_H
#define __NACC_Manager_H

#include <vdr/plugin.h>
#include <vdr/status.h>

#if VDRVERSNUM < 10510
#include <vdr/osdcontroller.h>
#endif

#include "config.h"
#include "receiver.h"
#include "osd.h"
#include "parser.h"
#include "interpreter.h"


///////////////////////////////////////////////////////////////////////////////

#if VDRVERSNUM < 10510
using namespace NonInteractiveOsdPatch;
#endif

class CCReceiver;
class CCParser;


///////////////////////////////////////////////////////////////////////////////


class CCManager : public cStatus, public cThread
#if VDRVERSNUM < 10510
, public cOsdListener
#endif
{
public:
  CCManager();
  virtual ~CCManager();

  void StartCC();
  void Stop();
  bool CCActive(void) { return (receiver != NULL); }
  virtual void ChannelSwitch(const cDevice* device, int channelNumber);
  
  void NoDataFound(void);
  void SetOsdColors(tColor bg, tColor fg);
  
protected:
  virtual void SetVolume(int Volume, bool Absolute);
  virtual void Replaying(const cControl *Control, const char *Name, const char *FileName, bool On);
	virtual void Show();
  virtual void Hide();
  virtual void Action(void);
        
private:    
  const cDevice*  currentDevice;
  const cChannel* currentChannel;
  
  CCParser* parser;
  Interpreter* interpreter;
  CCReceiver* receiver;
  
  CCOsd* osd;  
  
  cMutex* mutex;
  cMutex* stopMutex;
  bool requestStop;
  
};


///////////////////////////////////////////////////////////////////////////////


#endif //__NACC_Manager_H
