#ifndef __NACC_RECEIVER_H
#define __NACC_RECEIVER_H

#include <vdr/thread.h>
#include <vdr/receiver.h>

#include "parser.h"
#include "common.h"
//#include "manager.h"

///////////////////////////////////////////////////////////////////////////////
class CCParser;

class CCReceiver : public cReceiver
{
public:
#if VDRVERSNUM >= 10500
  CCReceiver(CCParser* p, tChannelID ChannelID, int Vpid, int* Apid = NULL, int* Dpid = NULL);
#else
  CCReceiver(CCParser* p, int Ca, int Vpid, int* Apid = NULL, int* Dpid = NULL);
#endif  
  virtual ~CCReceiver();
  
  void Attach(cDevice* device);
  void Detach(void);
  
protected:
  //virtual void Activate(bool On);
  virtual void Receive(uchar* Data, int Length);

private:
  void UpdatePictureType(uchar* Data, int Length);
  
  cDevice* attachedDevice;
  CCParser* parser;
  
  uint8_t  pictureType;
};


///////////////////////////////////////////////////////////////////////////////


#endif //__NACC_RECEIVER_H
